/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { Base, markType, enumGetBox, EnumUtil } from "igniteui-react-core";
import { WCNativeHelper } from "./WCNativeHelper";
import { DockManagerPaneType_$type } from "./DockManagerPaneType";
import { UnpinnedLocation_$type } from "./UnpinnedLocation";
import { ObservableCollection$1 } from "igniteui-react-core";
import { SplitPaneOrientation_$type } from "./SplitPaneOrientation";
import { DockManagerPoint } from "./DockManagerPoint";
/**
 * @hidden
 */
export let DockManagerPane = /*@__PURE__*/ (() => {
    class DockManagerPane extends Base {
        constructor() {
            super(...arguments);
            this.___mustPassByValue = true;
        }
        get d() {
            let ret_ = this.b().k("name");
            return ret_;
        }
        set d(a) {
            let value_ = a;
            this.b().s("name", value_);
        }
        static createFromNative(native_) {
            if (native_ == null) {
                return null;
            }
            let a = (native_.type);
            if (a == null || a == undefined) {
                return null;
            }
            switch (a.toLowerCase()) {
                case "splitpane":
                    {
                        let b = new SplitPane();
                        b.setNativeElement(native_);
                        return b;
                    }
                case "contentpane":
                    {
                        let c = new ContentPane();
                        c.setNativeElement(native_);
                        return c;
                    }
                case "tabgrouppane":
                    {
                        let d = new TabGroupPane();
                        d.setNativeElement(native_);
                        return d;
                    }
                case "documenthost":
                    {
                        let e = new DocumentHost();
                        e.setNativeElement(native_);
                        return e;
                    }
            }
            return null;
        }
    }
    DockManagerPane.$t = /*@__PURE__*/ markType(DockManagerPane, 'DockManagerPane');
    return DockManagerPane;
})();
/**
 * @hidden
 */
export let DocumentHost = /*@__PURE__*/ (() => {
    class DocumentHost extends DockManagerPane {
        constructor() {
            super(...arguments);
            this.g = new WCNativeHelper();
            this.j = null;
        }
        get h() {
            return this.g;
        }
        get nativeElement() {
            return this.j;
        }
        set nativeElement(a) {
            this.j = a;
            this.g.l = this.j;
        }
        setNativeElement(a) {
            this.nativeElement = a;
        }
        get l() {
            let ret_ = this.h.k("id");
            return ret_;
        }
        set l(a) {
            let value_ = a;
            this.h.s("id", value_);
        }
        get e() {
            let ret_ = this.h.k("type");
            ret_ = enumGetBox(DockManagerPaneType_$type, EnumUtil.getEnumValue(DockManagerPaneType_$type, this.h.f(DockManagerPaneType_$type, ret_)));
            return EnumUtil.getEnumValue(DockManagerPaneType_$type, ret_);
        }
        set e(a) {
            let value_ = enumGetBox(DockManagerPaneType_$type, a);
            value_ = WCNativeHelper.m(value_.toString());
            this.h.s("type", value_);
        }
        get f() {
            let ret_ = this.h.j("rootPane", (a) => new SplitPane());
            return ret_;
        }
        set f(a) {
            let value_ = a;
            this.h.s("rootPane", value_);
        }
        get i() {
            let ret_ = this.h.k("size");
            return ret_;
        }
        set i(a) {
            let value_ = a;
            this.h.s("size", value_);
        }
        b() {
            return this.h;
        }
    }
    DocumentHost.$t = /*@__PURE__*/ markType(DocumentHost, 'DocumentHost', DockManagerPane.$);
    return DocumentHost;
})();
/**
 * @hidden
 */
export let TabGroupPane = /*@__PURE__*/ (() => {
    class TabGroupPane extends DockManagerPane {
        constructor() {
            super(...arguments);
            this.g = new WCNativeHelper();
            this.m = null;
        }
        get h() {
            return this.g;
        }
        get nativeElement() {
            return this.m;
        }
        set nativeElement(a) {
            this.m = a;
            this.g.l = this.m;
        }
        setNativeElement(a) {
            this.nativeElement = a;
        }
        get o() {
            let ret_ = this.h.k("id");
            return ret_;
        }
        set o(a) {
            let value_ = a;
            this.h.s("id", value_);
        }
        get f() {
            let ret_ = this.h.k("type");
            ret_ = enumGetBox(DockManagerPaneType_$type, EnumUtil.getEnumValue(DockManagerPaneType_$type, this.h.f(DockManagerPaneType_$type, ret_)));
            return EnumUtil.getEnumValue(DockManagerPaneType_$type, ret_);
        }
        set f(a) {
            let value_ = enumGetBox(DockManagerPaneType_$type, a);
            value_ = WCNativeHelper.m(value_.toString());
            this.h.s("type", value_);
        }
        get e() {
            let ret_ = this.h.i("panes", (a) => new ContentPaneCollection(), (a) => new ContentPane());
            return ret_;
        }
        get l() {
            let ret_ = this.h.k("size");
            return ret_;
        }
        set l(a) {
            let value_ = a;
            this.h.s("size", value_);
        }
        get k() {
            let ret_ = this.h.k("selectedIndex");
            return ret_;
        }
        set k(a) {
            let value_ = a;
            this.h.s("selectedIndex", value_);
        }
        get i() {
            let ret_ = this.h.k("allowEmpty");
            return ret_;
        }
        set i(a) {
            let value_ = a;
            this.h.s("allowEmpty", value_);
        }
        get j() {
            let ret_ = this.h.k("isMaximized");
            return ret_;
        }
        set j(a) {
            let value_ = a;
            this.h.s("isMaximized", value_);
        }
        b() {
            return this.h;
        }
    }
    TabGroupPane.$t = /*@__PURE__*/ markType(TabGroupPane, 'TabGroupPane', DockManagerPane.$);
    return TabGroupPane;
})();
/**
 * @hidden
 */
export let ContentPane = /*@__PURE__*/ (() => {
    class ContentPane extends DockManagerPane {
        constructor() {
            super(...arguments);
            this.g = new WCNativeHelper();
            this.v = null;
        }
        b() {
            return this.h;
        }
        get h() {
            return this.g;
        }
        get nativeElement() {
            return this.v;
        }
        set nativeElement(a) {
            this.v = a;
            this.g.l = this.v;
        }
        setNativeElement(a) {
            this.nativeElement = a;
        }
        get ab() {
            let ret_ = this.h.k("id");
            return ret_;
        }
        set ab(a) {
            let value_ = a;
            this.h.s("id", value_);
        }
        get e() {
            let ret_ = this.h.k("type");
            ret_ = enumGetBox(DockManagerPaneType_$type, EnumUtil.getEnumValue(DockManagerPaneType_$type, this.h.f(DockManagerPaneType_$type, ret_)));
            return EnumUtil.getEnumValue(DockManagerPaneType_$type, ret_);
        }
        set e(a) {
            let value_ = enumGetBox(DockManagerPaneType_$type, a);
            value_ = WCNativeHelper.m(value_.toString());
            this.h.s("type", value_);
        }
        get x() {
            let ret_ = this.h.k("contentId");
            return ret_;
        }
        set x(a) {
            let value_ = a;
            this.h.s("contentId", value_);
        }
        get z() {
            let ret_ = this.h.k("header");
            return ret_;
        }
        set z(a) {
            let value_ = a;
            this.h.s("header", value_);
        }
        get aa() {
            let ret_ = this.h.k("headerId");
            return ret_;
        }
        set aa(a) {
            let value_ = a;
            this.h.s("headerId", value_);
        }
        get ac() {
            let ret_ = this.h.k("tabHeaderId");
            return ret_;
        }
        set ac(a) {
            let value_ = a;
            this.h.s("tabHeaderId", value_);
        }
        get ad() {
            let ret_ = this.h.k("unpinnedHeaderId");
            return ret_;
        }
        set ad(a) {
            let value_ = a;
            this.h.s("unpinnedHeaderId", value_);
        }
        get y() {
            let ret_ = this.h.k("floatingHeaderId");
            return ret_;
        }
        set y(a) {
            let value_ = a;
            this.h.s("floatingHeaderId", value_);
        }
        get t() {
            let ret_ = this.h.k("size");
            return ret_;
        }
        set t(a) {
            let value_ = a;
            this.h.s("size", value_);
        }
        get j() {
            let ret_ = this.h.k("allowClose");
            return ret_;
        }
        set j(a) {
            let value_ = a;
            this.h.s("allowClose", value_);
        }
        get m() {
            let ret_ = this.h.k("allowMaximize");
            return ret_;
        }
        set m(a) {
            let value_ = a;
            this.h.s("allowMaximize", value_);
        }
        get n() {
            let ret_ = this.h.k("allowPinning");
            return ret_;
        }
        set n(a) {
            let value_ = a;
            this.h.s("allowPinning", value_);
        }
        get k() {
            let ret_ = this.h.k("allowDocking");
            return ret_;
        }
        set k(a) {
            let value_ = a;
            this.h.s("allowDocking", value_);
        }
        get i() {
            let ret_ = this.h.k("acceptsInnerDock");
            return ret_;
        }
        set i(a) {
            let value_ = a;
            this.h.s("acceptsInnerDock", value_);
        }
        get l() {
            let ret_ = this.h.k("allowFloating");
            return ret_;
        }
        set l(a) {
            let value_ = a;
            this.h.s("allowFloating", value_);
        }
        get u() {
            let ret_ = this.h.k("unpinnedSize");
            return ret_;
        }
        set u(a) {
            let value_ = a;
            this.h.s("unpinnedSize", value_);
        }
        get s() {
            let ret_ = this.h.k("isPinned");
            return ret_;
        }
        set s(a) {
            let value_ = a;
            this.h.s("isPinned", value_);
        }
        get r() {
            let ret_ = this.h.k("isMaximized");
            return ret_;
        }
        set r(a) {
            let value_ = a;
            this.h.s("isMaximized", value_);
        }
        get f() {
            let ret_ = this.h.k("unpinnedLocation");
            ret_ = enumGetBox(UnpinnedLocation_$type, EnumUtil.getEnumValue(UnpinnedLocation_$type, this.h.f(UnpinnedLocation_$type, ret_)));
            return EnumUtil.getEnumValue(UnpinnedLocation_$type, ret_);
        }
        set f(a) {
            let value_ = enumGetBox(UnpinnedLocation_$type, a);
            value_ = WCNativeHelper.m(value_.toString());
            this.h.s("unpinnedLocation", value_);
        }
        get q() {
            let ret_ = this.h.k("hidden");
            return ret_;
        }
        set q(a) {
            let value_ = a;
            this.h.s("hidden", value_);
        }
        get o() {
            let ret_ = this.h.k("disabled");
            return ret_;
        }
        set o(a) {
            let value_ = a;
            this.h.s("disabled", value_);
        }
        get p() {
            let ret_ = this.h.k("documentOnly");
            return ret_;
        }
        set p(a) {
            let value_ = a;
            this.h.s("documentOnly", value_);
        }
    }
    ContentPane.$t = /*@__PURE__*/ markType(ContentPane, 'ContentPane', DockManagerPane.$);
    return ContentPane;
})();
/**
 * @hidden
 */
export let ContentPaneCollection = /*@__PURE__*/ (() => {
    class ContentPaneCollection extends ObservableCollection$1 {
        constructor() {
            super(ContentPane.$, 0);
        }
    }
    ContentPaneCollection.$t = /*@__PURE__*/ markType(ContentPaneCollection, 'ContentPaneCollection', /*@__PURE__*/ ObservableCollection$1.$.specialize(ContentPane.$));
    return ContentPaneCollection;
})();
/**
 * @hidden
 */
export let SplitPane = /*@__PURE__*/ (() => {
    class SplitPane extends DockManagerPane {
        constructor() {
            super(...arguments);
            this.i = new WCNativeHelper();
            this.q = null;
        }
        b() {
            return this.j;
        }
        get j() {
            return this.i;
        }
        get nativeElement() {
            return this.q;
        }
        set nativeElement(a) {
            this.q = a;
            this.i.l = this.q;
        }
        setNativeElement(a) {
            this.nativeElement = a;
        }
        get s() {
            let ret_ = this.j.k("id");
            return ret_;
        }
        set s(a) {
            let value_ = a;
            this.j.s("id", value_);
        }
        get f() {
            let ret_ = this.j.k("type");
            ret_ = enumGetBox(DockManagerPaneType_$type, EnumUtil.getEnumValue(DockManagerPaneType_$type, this.j.f(DockManagerPaneType_$type, ret_)));
            return EnumUtil.getEnumValue(DockManagerPaneType_$type, ret_);
        }
        set f(a) {
            let value_ = enumGetBox(DockManagerPaneType_$type, a);
            value_ = WCNativeHelper.m(value_.toString());
            this.j.s("type", value_);
        }
        get h() {
            let ret_ = this.j.k("orientation");
            ret_ = enumGetBox(SplitPaneOrientation_$type, EnumUtil.getEnumValue(SplitPaneOrientation_$type, this.j.f(SplitPaneOrientation_$type, ret_)));
            return EnumUtil.getEnumValue(SplitPaneOrientation_$type, ret_);
        }
        set h(a) {
            let value_ = enumGetBox(SplitPaneOrientation_$type, a);
            value_ = WCNativeHelper.m(value_.toString());
            this.j.s("orientation", value_);
        }
        get e() {
            let ret_ = this.j.i("panes", (a) => new DockManagerPaneCollection(), (a) => DockManagerPane.createFromNative(a));
            return ret_;
        }
        get p() {
            let ret_ = this.j.k("size");
            return ret_;
        }
        set p(a) {
            let value_ = a;
            this.j.s("size", value_);
        }
        get g() {
            let ret_ = this.j.j("floatingLocation", (a) => new DockManagerPoint());
            return ret_;
        }
        set g(a) {
            let value_ = a;
            this.j.s("floatingLocation", value_);
        }
        get o() {
            let ret_ = this.j.k("floatingWidth");
            return ret_;
        }
        set o(a) {
            let value_ = a;
            this.j.s("floatingWidth", value_);
        }
        get n() {
            let ret_ = this.j.k("floatingHeight");
            return ret_;
        }
        set n(a) {
            let value_ = a;
            this.j.s("floatingHeight", value_);
        }
        get l() {
            let ret_ = this.j.k("floatingResizable");
            return ret_;
        }
        set l(a) {
            let value_ = a;
            this.j.s("floatingResizable", value_);
        }
        get k() {
            let ret_ = this.j.k("allowEmpty");
            return ret_;
        }
        set k(a) {
            let value_ = a;
            this.j.s("allowEmpty", value_);
        }
        get m() {
            let ret_ = this.j.k("isMaximized");
            return ret_;
        }
        set m(a) {
            let value_ = a;
            this.j.s("isMaximized", value_);
        }
    }
    SplitPane.$t = /*@__PURE__*/ markType(SplitPane, 'SplitPane', DockManagerPane.$);
    return SplitPane;
})();
/**
 * @hidden
 */
export let DockManagerPaneCollection = /*@__PURE__*/ (() => {
    class DockManagerPaneCollection extends ObservableCollection$1 {
        constructor() {
            super(DockManagerPane.$, 0);
        }
    }
    DockManagerPaneCollection.$t = /*@__PURE__*/ markType(DockManagerPaneCollection, 'DockManagerPaneCollection', /*@__PURE__*/ ObservableCollection$1.$.specialize(DockManagerPane.$));
    return DockManagerPaneCollection;
})();
